routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () { return view('pages.home');});

Route::resource('pacientes','PacientsController');
Route::resource('usuario','UsuarioController');

Route::group(['middleware'=>'auth'], function () {
	Route::get('permissions-all-users',['middleware'=>'check-permission:user|admin|superadmin','uses'=>'HomeController@allUsers']);
	Route::get('permissions-admin-superadmin',['middleware'=>'check-permission:admin|superadmin','uses'=>'HomeController@adminSuperadmin']);
	Route::get('permissions-superadmin',['middleware'=>'check-permission:superadmin','uses'=>'HomeController@superadmin']);
});
Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

Route::get('logout', '\App\Http\Controllers\Auth\LoginController@logout');

app/Http/Controllers/UsuarioController.php
<?php

namespace App\Http\Controllers;

use App\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Foundation\Auth\RegistersUsers;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Validator;


class UsuarioController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */

    public function __construct()
    {
        $this->middleware('auth');
    }


    public function index()
    {
        if(!checkPermission(['admin','superadmin']))
        {
            return redirect()->route('home');
        }
    
        $User = User::where('is_permission','!=', '2')->paginate(5);
  
        return view('Usuarios.userList',compact('User'))->with('i', (request()->input('page', 1) - 1) * 5);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        if(!checkPermission(['admin','superadmin']))
        {
            return redirect()->route('home');
        }
       
        return view('Usuarios.create');

    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        if(!checkPermission(['admin','superadmin']))
        {
            return redirect()->route('home');
        }

        $request->validate([
            'name' => 'required',
            'email' => 'required',
            'password' => 'required|min:6|required_with:password_confirmation|same:password_confirmation',
            'password_confirmation' => 'required'
        ]);

     
  
        User::create([
            'name' => $request->input('name'),
            'email' => $request->input('email'),
            'password' => Hash::make($request->input('password')),
            'is_permission' => $request->input('is_permission')
        ]);
   
        return redirect("usuario")->with('success','Usuário criado com sucesso.');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\User  $user
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        if(!checkPermission(['admin','superadmin']))
        {
            return redirect()->route('home');
        }
        $User = User::find($id);
        return view('Usuarios.show',compact('User'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\User  $User
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        if(!checkPermission(['admin','superadmin']))
        {
            return redirect()->route('home');
        }
        $User = User::find($id);
        return view('Usuarios.edit',compact('User'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\User  $User
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        if($request->input('password') == "")
        {
            DB::table('users')
            ->where('id', $id)
            ->update([
            'id' => $id,
            'name' => $request->input('name'),
            'email' => $request->input('email'),
            'is_permission' => $request->input('is_permission')
        ]); 
        }else{
      
        DB::table('users')
            ->where('id', $id)
            ->update([
            'id' => $id,
            'name' => $request->input('name'),
            'email' => $request->input('email'),
            'password' => Hash::make($request->input('password')),
            'is_permission' => $request->input('is_permission')
        ]);
    }
        return redirect('usuario')->with('success','Usuário atualizado com sucesso');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\User  $User
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $User = User::find($id);
        $User -> delete();
        return redirect('usuario')->with('success','Usuário removido com sucesso');
    }

}

resources/views/Usuarios/create.blade.php
@extends('layout.app')

@section('content')
<div class="container mt-4" style="margin-bottom:20vh;">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header text-center">{{ __('Criar novo usuário') }}</div>

                <div class="card-body">
                    <form method="POST" action="{{ route('usuario.store') }}">
                        @csrf

                        <div class="form-group row">
                            <label for="name" class="col-md-4 col-form-label text-md-right">{{ __('Nome') }}</label>

                            <div class="col-md-6">
                                <input id="name" type="text" class="form-control @error('name') is-invalid @enderror"
                                    name="name" value="{{ old('name') }}" required autocomplete="name" autofocus>

                                @error('name')
                                <span class="invalid-feedback" role="alert">
                                    <strong>{{ $message }}</strong>
                                </span>
                                @enderror
                            </div>
                        </div>

                        <div class="form-group row">
                            <label for="email" class="col-md-4 col-form-label text-md-right">{{ __('E-Mail') }}</label>

                            <div class="col-md-6">
                                <input id="email" type="email" class="form-control @error('email') is-invalid @enderror"
                                    name="email" value="{{ old('email') }}" required autocomplete="email">

                                @error('email')
                                <span class="invalid-feedback" role="alert">
                                    <strong>{{ $message }}</strong>
                                </span>
                                @enderror
                            </div>
                        </div>

                        <div class="form-group row">
                            <label for="password"
                                class="col-md-4 col-form-label text-md-right">{{ __('Senha') }}</label>

                            <div class="col-md-6">
                                <input id="password" type="password"
                                    class="form-control @error('password') is-invalid @enderror" name="password"
                                    required autocomplete="new-password">

                                @error('password')
                                <span class="invalid-feedback" role="alert">
                                    <strong>{{ $message }}</strong>
                                </span>
                                @enderror
                            </div>
                        </div>

                        <div class="form-group row">
                            <label for="password-confirm"
                                class="col-md-4 col-form-label text-md-right">{{ __('Confirmação da senha') }}</label>

                            <div class="col-md-6">
                                <input id="password-confirm" type="password" class="form-control"
                                    name="password_confirmation" required autocomplete="new-password">
                            </div>
                        </div>

                        @if(checkPermission(['admin','superadmin']))
                        <div class="form-group row">
                            <label for="is_permission"
                                class="col-md-4 col-form-label text-md-right">{{ __('Permissão') }}</label>

                            <div class="col-md-6 hidden">
                                <select id="is_permission" name="is_permission" class="form-control">
                                    <option value="1">Administrador</option>
                                    <option value="3" selected>Usuário</option>

                                </select>

                                @error('is_permission')
                                <span class="invalid-feedback" role="alert">
                                    <strong>{{ $message }}</strong>
                                </span>
                                @enderror
                            </div>
                        </div>
                        @else
                        <div class="form-group row" style="display:none;">
                            <label for="is_permission"
                                class="col-md-4 col-form-label text-md-right">{{ __('Permission') }}</label>

                            <div class="col-md-6 hidden">
                                <input id="is_permission" type="text"
                                    class="form-control @error('is_permission') is-invalid @enderror"
                                    name="is_permission" value="0" required>

                                @error('is_permission')
                                <span class="invalid-feedback" role="alert">
                                    <strong>{{ $message }}</strong>
                                </span>
                                @enderror
                            </div>
                        </div>
                        @endif

                        <div class="form-group row mb-0">
                            <div class="col-md-4 offset-md-3">
                                <button type="submit" class="btn btn-success">
                                    {{ __('Criar usuário') }}
                                </button>
                            </div>
                            <div class="col-md-4">
                                <a class="btn btn-primary" href="{{ route('usuario.index') }}"> Voltar</a>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/Usuarios/edit.blade.php
@extends('layout.app')
@section('content')
<div class="container mt-5">

    <form action="{{ route('usuario.update',$User->id) }}" method="POST">
        @csrf
        @method('PUT')
        <div class="card">
            <div class="card-header text-center">{{ __('Editar Usuário') }}</div>
            <div class="card-body">
                <div class="form-group row">
                    <label for="name" class="col-md-4 col-form-label text-md-right">{{ __('Nome') }}</label>

                    <div class="col-md-6">
                        <input id="name" type="text" class="form-control @error('name') is-invalid @enderror"
                            name="name" value="{{$User->name}}" required autocomplete="name" autofocus>

                        @error('name')
                        <span class="invalid-feedback" role="alert">
                            <strong>{{ $message }}</strong>
                        </span>
                        @enderror
                    </div>
                </div>

                <div class="form-group row">
                    <label for="email" class="col-md-4 col-form-label text-md-right">{{ __('E-Mail') }}</label>

                    <div class="col-md-6">
                        <input id="email" type="email" class="form-control @error('email') is-invalid @enderror"
                            name="email" value="{{$User->email }}" required autocomplete="email">

                        @error('email')
                        <span class="invalid-feedback" role="alert">
                            <strong>{{ $message }}</strong>
                        </span>
                        @enderror
                    </div>
                </div>
                <div class="form-group row">
                    <label for="password" class="col-md-4 col-form-label text-md-right">{{ __('Senha') }}</label>

                    <div class="col-md-6">
                        <input id="password" type="password"
                            class="form-control @error('password') is-invalid @enderror" name="password"
                            autocomplete="new-password">

                        @error('password')
                        <span class="invalid-feedback" role="alert">
                            <strong>{{ $message }}</strong>
                        </span>
                        @enderror
                    </div>
                </div>
                <div class="form-group row">
                    <label for="password-confirm"
                        class="col-md-4 col-form-label text-md-right">{{ __('Confirmação da senha') }}</label>

                    <div class="col-md-6">
                        <input id="password-confirm" type="password" class="form-control" name="password_confirmation"
                            autocomplete="new-password">
                    </div>
                </div>
                <div class="form-group row">
                    <label for="is_permission" class="col-md-4 col-form-label text-md-right">Permissão</label>

                    <div class="col-md-6 hidden">
                        <select id="is_permission" name="is_permission" class="form-control">
                            @if($User->is_permission == 1)
                            <option value="1" selected>Administrador</option>
                            @else
                            <option value="1">Administrador</option>
                            @endif

                            @if($User->is_permission != 1)
                            <option value="3" selected>Usuário</option>
                            @else
                            <option value="3">Usuário</option>
                            @endif
                        </select>
                    </div>
                </div>
                <div class="form-group row mb-0">
                    <div class="col-md-3 offset-md-4">
                        <button type="submit" class="btn btn-success">
                            {{ __('Salvar') }}
                        </button>
                    </div>
                    <div class="col-md-2">
                        <a class="btn btn-primary" href="{{ route('usuario.index') }}"> Voltar</a>
                    </div>
                </div>
            </div>
        </div>
    </form>
</div>
@endsection

resources/views/Usuarios/show.blade.php
@extends('layout.app')
@section('content')
<div class="container mt-5">


    <div class="card">
        <div class="card-header text-center">{{ __('Detalhes do Usuário') }}</div>

        <div class="card-body">


            <div class="form-group row">
                <label for="name" class="col-md-4 col-form-label text-md-right">Nome</label>

                <div class="col-md-6">
                    <input id="name" type="text" class="form-control " name="name" value="{{$User->name}}" disabled>

                </div>
            </div>

            <div class="form-group row">
                <label for="email" class="col-md-4 col-form-label text-md-right">E-Mail</label>

                <div class="col-md-6">
                    <input id="email" type="email" class="form-control " name="email" value="{{$User->email}}" disabled>

                </div>
            </div>




            <div class="form-group row">
                <label for="is_permission" class="col-md-4 col-form-label text-md-right">Permissão</label>

                <div class="col-md-6 hidden">
                    <input id="is_permission" type="text" class="form-control " name="is_permission" value="@switch($User->is_permission)
                        @case(1)
Administrador
                        @break
        
                        @case(2)
Super Administrador
                        @break
        
                        @default
Usuário Padrão
                        @endswitch" disabled>

                </div>
            </div>
            <div class="form-group row mb-0">
                <div class="col-md-6 offset-md-4">
                    <a class="btn btn-primary" href="{{ route('usuario.index') }}"> Voltar</a>
                </div>
            </div>
            
        </div>
        
    </div>

     
   
</div>
@endsection

resources/views/Usuarios/userList.blade.php
@extends('layout.app')

@section('content')
<div class="container mt-5">
    <div class="card">
        <div class="card-header text-center">{{ __('Usuários') }}</div>
        <div class="card-body">
            <div class="row">
                <div class="col-lg-12 margin-tb">

                    <div class="pull-right mt-4 mb-4">
                        <a class="btn btn-success" href="{{ route('usuario.create') }}"> Novo Usuário</a>
                    </div>
                </div>
            </div>

            @if ($message = Session::get('success'))
            <div class="alert alert-success">
                <p>{{ $message }}</p>
            </div>
            @endif

            @if(count($User) == 0)
            <div class="row">
                <div class="col-md-12 hscroll text-center">
                    <span>Não foram encontrados registros.</span>
                </div>
            </div>
            
            @elseif (count($User) > 0)
            <div class="row">
                <div class="col-md-12 hscroll">
                    <table class="table table-bordered ">
                        <tr>
                            <th>Nome</th>
                            <th>E-Mail</th>
                            <th>Permissão</th>
                            <th>Ações</th>
                        </tr>
                        @foreach ($User ?? '' as $user)
                        <tr>
                            <td>{{ $user->name }}</td>
                            <td>{{ $user->email }}</td>
                            <td> @if($user->is_permission == 1)
                                Administrador
                                @else
                                Usuário
                                @endif</td>
                            <td>
                                <form id="form{{$user->id}}" action="{{ route('usuario.destroy',$user->id) }}" method="POST">
                                    @csrf
                                    @method('DELETE')
                      
                                    
                                    <a class="btn btn-info" href="{{ route('usuario.show',$user->id) }}">Detalhes</a>
                                    <a class="btn btn-primary" href="{{ route('usuario.edit',$user->id) }}">Editar</a>
                                    @if(checkPermission(['superadmin']))

                                    <a href="javascript:;" data-toggle="modal" onclick="deleteData({{$user->id}})" data-target="#DeleteModal" class="btn btn-xs btn-danger">Remover</a>
                                     
                                    @endif
                                </form>
                            </td>

                        </tr>
                        @endforeach
                    </table>
                </div>
            </div>
           
         

            {!! $User ?? ''->links() !!}
        </div>
    </div>

    <div id="DeleteModal" class="modal fade text-danger" role="dialog">
        <div class="modal-dialog ">
          <!-- Modal content-->
          <form action="{{ route('usuario.destroy',$user->id) }}" method="POST">
            @csrf
            @method('DELETE')

              <div class="modal-content">
                  <div class="modal-header bg-danger">
                      <!-- <button type="button" class="close" data-dismiss="modal">&times;</button> -->
                      <h4 class="modal-title text-center" style="color:white;">Remover Usuário</h4>
                  </div>
                  <div class="modal-body">
               
                      <p class="text-center">Tem certeza que deseja remover o usuário <span id="nomeusuario" hidden></span> ?</p>
                  </div>
                  <div class="modal-footer text-center">
                      
                          <button type="button" class="btn btn-success" data-dismiss="modal">Cancelar</button>
                          <button type="button" class="btn btn-danger" onclick="submitform()">Remover</button>
                       
                  </div>
              </div>
          </form>
        </div>
       </div>
       @endif
</div>

<script type="text/javascript">
    function deleteData(id)
    {
        $("#nomeusuario").html(id)
    }
    function submitform(id)
    {
        $("#form"+$("#nomeusuario").html()).submit();
    }
 </script>

@endsection